<html>
<head>
<title>Ogre::RTShader::ShaderGenerator::SGSceneManagerListener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html">SGSceneManagerListener</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener" --><!-- doxytag: inherits="Ogre::SceneManager::Listener,Ogre::AllocatedObject" -->
<p>Shader generator scene manager sub class.  
 <a href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::ShaderGenerator::SGSceneManagerListener:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener_inherit__map" id="Ogre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1SceneManager_1_1Listener.html" title="Class that allows listening in on the various stages of SceneManager processing, so that custom behav..." alt="" coords="5,5,203,35"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="227,5,381,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a83776bab4dc094d2c7613c52df8a8c3c">SGSceneManagerListener</a> (<a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a> *owner)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#abd9bdb17d982f4b529bb591daa0724e0">preFindVisibleObjects</a> (<a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *source, <a class="el" href="classOgre_1_1SceneManager.html#a51db39cc4fa15b28086a1793d42fc827">SceneManager::IlluminationRenderStage</a> irs, <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Listener overridden function notify the shader generator when finding visible objects process started.  <a href="#abd9bdb17d982f4b529bb591daa0724e0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#af36f5d78e45614ecae54722592818b2e">postFindVisibleObjects</a> (<a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *source, <a class="el" href="classOgre_1_1SceneManager.html#a51db39cc4fa15b28086a1793d42fc827">SceneManager::IlluminationRenderStage</a> irs, <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *v)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called after searching for visible objects in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>.  <a href="#af36f5d78e45614ecae54722592818b2e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#af6c4f9d4ea7eab3a5191618d6cbeea21">shadowTexturesUpdated</a> (size_t numberOfShadowTextures)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes).  <a href="#af6c4f9d4ea7eab3a5191618d6cbeea21"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a54ea4b8b051acb47001eeadcf9c8bb7d">shadowTextureCasterPreViewProj</a> (<a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *camera, size_t iteration)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This event occurs just before the view &amp; projection matrices are set for rendering into a shadow texture.  <a href="#a54ea4b8b051acb47001eeadcf9c8bb7d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a45b16b4d1b134cbce3b43bfca2a0786c">shadowTextureReceiverPreViewProj</a> (<a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *frustum)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This event occurs just before the view &amp; projection matrices are set for re-rendering a shadow receiver.  <a href="#a45b16b4d1b134cbce3b43bfca2a0786c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#aaafbc877eaf190b86163c1e171a4400e">preUpdateSceneGraph</a> (<a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *source, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *camera)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called prior to updating the scene graph in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>.  <a href="#aaafbc877eaf190b86163c1e171a4400e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#ad8f0c1e1efaccade0663e416d76b960c">postUpdateSceneGraph</a> (<a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *source, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *camera)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called after updating the scene graph in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>.  <a href="#ad8f0c1e1efaccade0663e416d76b960c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a5ef1be858fe331867653fbb8aa819494">sortLightsAffectingFrustum</a> (<a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> &amp;lightList)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Hook to allow the listener to override the ordering of lights for the entire frustum.  <a href="#a5ef1be858fe331867653fbb8aa819494"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a9d5463252458a8852b0011935e6f5bb5">sceneManagerDestroyed</a> (<a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *source)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Event notifying the listener of the <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>'s destruction.  <a href="#a9d5463252458a8852b0011935e6f5bb5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a869833969b25e4ce50e356df76b00f9c">mOwner</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Shader generator scene manager sub class. </p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00707">707</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a83776bab4dc094d2c7613c52df8a8c3c"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::SGSceneManagerListener" ref="a83776bab4dc094d2c7613c52df8a8c3c" args="(ShaderGenerator *owner)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a83776bab4dc094d2c7613c52df8a8c3c">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::SGSceneManagerListener</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a> *&#160;</td>
          <td class="paramname"><em>owner</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00710">710</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="af36f5d78e45614ecae54722592818b2e"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::postFindVisibleObjects" ref="af36f5d78e45614ecae54722592818b2e" args="(SceneManager *source, SceneManager::IlluminationRenderStage irs, Viewport *v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#af36f5d78e45614ecae54722592818b2e">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::postFindVisibleObjects</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html#a51db39cc4fa15b28086a1793d42fc827">SceneManager::IlluminationRenderStage</a>&#160;</td>
          <td class="paramname"><em>irs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called after searching for visible objects in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Note that the render queue at this stage will be full of the current scenes contents, ready for rendering. You may manually add renderables to this queue if you wish. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>The <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> instance raising this event. </td></tr>
    <tr><td class="paramname">irs</td><td>The stage of illumination being dealt with. IRS_NONE for a regular render, IRS_RENDER_TO_TEXTURE for a shadow caster render. </td></tr>
    <tr><td class="paramname">v</td><td>The viewport being updated. You can get the camera from here. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#ab57b560ea987d8dae9901908d0ab6f28">Ogre::SceneManager::Listener</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00724">724</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad8f0c1e1efaccade0663e416d76b960c"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::postUpdateSceneGraph" ref="ad8f0c1e1efaccade0663e416d76b960c" args="(SceneManager *source, Camera *camera)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#ad8f0c1e1efaccade0663e416d76b960c">Ogre::SceneManager::Listener::postUpdateSceneGraph</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>camera</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called after updating the scene graph in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is called after updating the scene graph for a camera. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>The <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> instance raising this event. </td></tr>
    <tr><td class="paramname">camera</td><td>The camera being updated. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreSceneManager_8h_source.html#l00240">240</a> of file <a class="el" href="OgreSceneManager_8h_source.html">OgreSceneManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="abd9bdb17d982f4b529bb591daa0724e0"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::preFindVisibleObjects" ref="abd9bdb17d982f4b529bb591daa0724e0" args="(SceneManager *source, SceneManager::IlluminationRenderStage irs, Viewport *v)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#abd9bdb17d982f4b529bb591daa0724e0">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::preFindVisibleObjects</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html#a51db39cc4fa15b28086a1793d42fc827">SceneManager::IlluminationRenderStage</a>&#160;</td>
          <td class="paramname"><em>irs</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&#160;</td>
          <td class="paramname"><em>v</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Listener overridden function notify the shader generator when finding visible objects process started. </p>

<p>Reimplemented from <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a2c0007528c775ca51c95fd5e7f7aa4db">Ogre::SceneManager::Listener</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00718">718</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html#af344971be9f1c3055e3ed7312d8ffb20">Ogre::RTShader::ShaderGenerator::preFindVisibleObjects()</a>.</p>

</div>
</div>
<a class="anchor" id="aaafbc877eaf190b86163c1e171a4400e"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::preUpdateSceneGraph" ref="aaafbc877eaf190b86163c1e171a4400e" args="(SceneManager *source, Camera *camera)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#aaafbc877eaf190b86163c1e171a4400e">Ogre::SceneManager::Listener::preUpdateSceneGraph</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>source</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>camera</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called prior to updating the scene graph in this <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This is called before updating the scene graph for a camera. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">source</td><td>The <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> instance raising this event. </td></tr>
    <tr><td class="paramname">camera</td><td>The camera being updated. </td></tr>
  </table>
  </dd>
</dl>

<p>Definition at line <a class="el" href="OgreSceneManager_8h_source.html#l00231">231</a> of file <a class="el" href="OgreSceneManager_8h_source.html">OgreSceneManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9d5463252458a8852b0011935e6f5bb5"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::sceneManagerDestroyed" ref="a9d5463252458a8852b0011935e6f5bb5" args="(SceneManager *source)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a9d5463252458a8852b0011935e6f5bb5">Ogre::SceneManager::Listener::sceneManagerDestroyed</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&#160;</td>
          <td class="paramname"><em>source</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event notifying the listener of the <a class="el" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a>'s destruction. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1Terrain.html#a09baa91af04f211ee9e8e8f60d9e6c39">Ogre::Terrain</a>.</p>

<p>Definition at line <a class="el" href="OgreSceneManager_8h_source.html#l00347">347</a> of file <a class="el" href="OgreSceneManager_8h_source.html">OgreSceneManager.h</a>.</p>

</div>
</div>
<a class="anchor" id="a54ea4b8b051acb47001eeadcf9c8bb7d"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTextureCasterPreViewProj" ref="a54ea4b8b051acb47001eeadcf9c8bb7d" args="(Light *light, Camera *camera, size_t iteration)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a54ea4b8b051acb47001eeadcf9c8bb7d">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTextureCasterPreViewProj</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&#160;</td>
          <td class="paramname"><em>camera</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>iteration</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This event occurs just before the view &amp; projection matrices are set for rendering into a shadow texture. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>You can use this event hook to perform some custom processing, such as altering the camera being used for rendering the light's view, including setting custom view &amp; projection matrices if you want to perform an advanced shadow technique. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">light</td><td>Pointer to the light for which shadows are being rendered </td></tr>
    <tr><td class="paramname">camera</td><td>Pointer to the camera being used to render </td></tr>
    <tr><td class="paramname">iteration</td><td>For lights that use multiple shadow textures, the iteration number </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a012a1c3dcf2efbd8245fd125e7fc1b64">Ogre::SceneManager::Listener</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00735">735</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a45b16b4d1b134cbce3b43bfca2a0786c"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTextureReceiverPreViewProj" ref="a45b16b4d1b134cbce3b43bfca2a0786c" args="(Light *light, Frustum *frustum)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a45b16b4d1b134cbce3b43bfca2a0786c">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTextureReceiverPreViewProj</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Light.html">Light</a> *&#160;</td>
          <td class="paramname"><em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Frustum.html">Frustum</a> *&#160;</td>
          <td class="paramname"><em>frustum</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>This event occurs just before the view &amp; projection matrices are set for re-rendering a shadow receiver. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>You can use this event hook to perform some custom processing, such as altering the projection frustum being used for rendering the shadow onto the receiver to perform an advanced shadow technique. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">light</td><td>Pointer to the light for which shadows are being rendered </td></tr>
    <tr><td class="paramname">frustum</td><td>Pointer to the projection frustum being used to project the shadow texture </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#aa05def0ab89195c585b5467059245641">Ogre::SceneManager::Listener</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00741">741</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="af6c4f9d4ea7eab3a5191618d6cbeea21"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTexturesUpdated" ref="af6c4f9d4ea7eab3a5191618d6cbeea21" args="(size_t numberOfShadowTextures)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#af6c4f9d4ea7eab3a5191618d6cbeea21">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::shadowTexturesUpdated</a> </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>numberOfShadowTextures</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Event raised after all shadow textures have been rendered into for all queues / targets but before any other geometry has been rendered (including main scene geometry and any additional shadow receiver passes). </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>This callback is useful for those that wish to perform some additional processing on shadow textures before they are used to render shadows. For example you could perform some filtering by rendering the existing shadow textures into another alternative shadow texture with a shader.] </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>This event will only be fired when texture shadows are in use. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">numberOfShadowTextures</td><td>The number of shadow textures in use </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#aa2c3ceb367f47c3721e9d1843288d341">Ogre::SceneManager::Listener</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00730">730</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<a class="anchor" id="a5ef1be858fe331867653fbb8aa819494"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::sortLightsAffectingFrustum" ref="a5ef1be858fe331867653fbb8aa819494" args="(LightList &amp;lightList)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1SceneManager_1_1Listener.html#a5ef1be858fe331867653fbb8aa819494">Ogre::SceneManager::Listener::sortLightsAffectingFrustum</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__General.html#gaab30ef14aae93306a6044cb38d835f0c">LightList</a> &amp;&#160;</td>
          <td class="paramname"><em>lightList</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Hook to allow the listener to override the ordering of lights for the entire frustum. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>Whilst ordinarily lights are sorted per rendered object (</dd></dl>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1MovableObject.html#a2d4c926ce07f3a1cb0e59d9d60aac76b" title="Gets a list of lights, ordered relative to how close they are to this movable object.">MovableObject::queryLights</a>), texture shadows adds another issue in that, given there is a finite number of shadow textures, we must choose which lights to render texture shadows from based on the entire frustum. These lights should always be listed first in every objects own <a class="el" href="structOgre_1_1list.html">list</a>, followed by any other lights which will not cast texture shadows (either because they have shadow casting off, or there aren't enough shadow textures to service them). </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This hook allows you to override the detailed ordering of the lights per frustum. The default ordering is shadow casters first (which you must also respect if you override this method), and ordered by distance from the camera within those 2 groups. Obviously the closest lights with shadow casting enabled will be listed first. Only lights within the range of the frustum will be in the list. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">lightList</td><td>The list of lights within range of the frustum which you may sort. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>true if you sorted the list, false otherwise. </dd></dl>

<p>Definition at line <a class="el" href="OgreSceneManager_8h_source.html#l00343">343</a> of file <a class="el" href="OgreSceneManager_8h_source.html">OgreSceneManager.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a869833969b25e4ce50e356df76b00f9c"></a><!-- doxytag: member="Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::mOwner" ref="a869833969b25e4ce50e356df76b00f9c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator.html">ShaderGenerator</a>* <a class="el" href="classOgre_1_1RTShader_1_1ShaderGenerator_1_1SGSceneManagerListener.html#a869833969b25e4ce50e356df76b00f9c">Ogre::RTShader::ShaderGenerator::SGSceneManagerListener::mOwner</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderGenerator_8h_source.html#l00748">748</a> of file <a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderGenerator_8h_source.html">OgreShaderGenerator.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:32
</p>
</body>
</html>
